#include "sched.h"

#include "process.h"
#include "console.h"


//#define DEBUG 1

extern task_struct *user1_pcb;
extern task_struct *user2_pcb;
extern task_struct *init_pcb;
extern task_struct *current;
extern tss_struct *cpu_tss;
extern task_struct *task_array[MAX_TASK];
extern int cur_task;

	unsigned int count = 0;


void init_scheduler(void)
{
	count = 0;
}

void schedule(void)
{

	task_struct *prev, *next;
	unsigned int *p_ebp;
	unsigned int *prev_regs;
	unsigned int *regs_in_stack;
	int l;
	unsigned int next_regs;
#ifdef DEBUG
	thread_struct *temp_thread;
#endif


	// choose next task
#ifdef DEBUG
	caos_printf("cur=%d, ", cur_task);
#endif
	prev = task_array[cur_task];
	if (cur_task == MAX_TASK-1) 
		cur_task = 0;
	else 
		cur_task++;
	next = task_array[cur_task];
#ifdef DEBUG
	caos_printf("next=%d\n", cur_task);
#endif

	asm volatile (
			"mov %%ebp, %0	\n\t"
			: "=m"(p_ebp)
	);
	
	// 
	// ebp+4*15 = CS
	//
	if ( (p_ebp[15] % 0x3) == 0)
		return;

	//
	// ebp -> ebp original value
	//        return address of schedule
	// ebp+4*2 -> starting point of context
	regs_in_stack = &(p_ebp[2]);

	prev_regs = (unsigned int *)&(prev->thread);

	//
	// copy register values in stack to previous process context
#ifdef DEBUG
	//caos_printf("REGS in stack(%x)", (unsigned int)p_ebp);
#endif
	for (l=0; l<17; l++) {
		prev_regs[l] = regs_in_stack[l];
#ifdef DEBUG
	//	caos_printf("[%d]%x ", l, regs_in_stack[l]);
#endif
	}
#ifdef DEBUG
	//caos_printf("\n");
#endif

	next_regs = (unsigned int)&(next->thread);

#ifdef DEBUG
	caos_printf("prev PCB [%x] : ", (unsigned int)prev);
	caos_printf("%x %x %x %x %x\n", prev->thread.eip,
								prev->thread.cs, prev->thread.eflags,
								prev->thread.esp, prev->thread.ss);


	caos_printf("next pcb [%x] : ", (unsigned int)next_regs);
	temp_thread = (thread_struct *)next_regs;

	caos_printf("%x %x %x %x %x\n", temp_thread->eip,
								temp_thread->cs, temp_thread->eflags,
								temp_thread->esp, temp_thread->ss);
#endif

	asm volatile (
		"mov %2, %%eax		\n\t"		// change kernel mode stack
		"mov %%eax, %1		\n\t"
		//
		// Pointer of next task must be stored
		// before stack is changed!!
		// If stack pointer is changed,
		// no local variables can be accessed.
		// But global variables is not refered with stack pointer.
		//
		"mov %3, %%eax		\n\t"

		"mov %%ebp, %%esp	\n\t"
		"pop %%ebp			\n\t"
		"add $4, %%esp		\n\t"		// pop return address
		"add $68, %%esp		\n\t"		// pop context of prev task
		"mov %%esp, %0		\n\t"		// store prev stack-pointer

		"mov %%eax, %%esp		\n\t"		// extract context of next task
		"popal				\n\t"
		"pop %%ds		\n\t"
		"pop %%es		\n\t"
		"pop %%fs		\n\t"
		"pop %%gs		\n\t"
		"iret				\n\t"
		: "=m"(prev->thread.esp0),"=m"(cpu_tss->esp0)
		: "m"(next->thread.esp0),"m"(next_regs)
	);
	return;
}
	
	/*
	asm volatile (
		//"mov %%ebp, %%esp	\n\t"
		//"pop %%ebp			\n\t"
		//"add $72, %%esp		\n\t"
		//"mov %%esp, %0		\n\t"
		
		//"mov %1, %%esp		\n\t"
		//"pushal				\n\t"
		//"mov %%esp, %%eax		\n\t"
		//"mov %7, %%esp		\n\t"
		//"popal				\n\t"
		//"pop %%ebx		\n\t"
		//"pop %%ebx		\n\t"
		//"pop %%ebx		\n\t"
		//"pop %%ebx		\n\t"

		"mov $0x33, %%ax	\n\t"
		"mov %%ax, %%ds		\n\t"
		"mov %%ax, %%es		\n\t"
		"mov %%ax, %%fs		\n\t"
		"mov %%ax, %%gs		\n\t"

		"mov $0x40000000, %%eax\n\t"
		"pushl %%eax	\n\t"
		"mov $0x2b, %%eax\n\t"
		"pushl %%eax	\n\t"
		"mov $0x200, %%eax\n\t"
		"pushl %%eax	\n\t"
		"mov $0x40002ffc, %%eax\n\t"
		"pushl %%eax	\n\t"
		"mov $0x33, %%eax\n\t"
		"pushl %%eax	\n\t"
		"iret				\n\t"
		//"pop %%ebx		\n\t"
		//"mov %%ebx, %1		\n\t"
		//"pop %%ebx		\n\t"
		//"mov %%ebx, %2		\n\t"
		//"pop %%ebx		\n\t"
		//"mov %%ebx, %3		\n\t"
		//"pop %%ebx		\n\t"
		//"mov %%ebx, %4		\n\t"
		//"pop %%ebx		\n\t"
		//"mov %%ebx, %5		\n\t"

		//"mov %%eax, %%esp	\n\t"

		//"popal		\n\t"
		: "=m"(cpu_tss->thread.esp0),"=m"(eip),"=m"(cs),"=m"(eflags),"=m"(esp),"=m"(ss), "=m"(tmp)
		: "m"(next_regs)
	);

	return;
}

*/
